/**
 * ajustf.java - jpq - 27/09/99 - 03/04/00 - 28/08/00
 * jdk1.2 - double-buffering
 * modification et ajout de geo et de main() le 09/01/18. Mise à jour SE 18 le 27/09/22.
 */

import java.awt.event.*;
import java.awt.*;
import javax.swing.*;
import java.util.*;
import geo.*;

public class ajustf extends Panel {
	static final long serialVersionUID = 220927L;
	controles C;
	dessin D;
	table T;
	static Repere R;
	static PointLibre O, I;
	double ux, uy;
	TextField tf, tux, tuy;
	Button ok;
	String s;
	Font f = new Font (Font.SANS_SERIF, Font.PLAIN, 10);

	public ajustf() {
		ux = 50.0;
		uy = 50.0;
		s = "";

		setLayout (new BorderLayout ());
		add (C = new controles(), BorderLayout.NORTH);
		add (D = new dessin(), BorderLayout.CENTER);
		add (T = new table(), BorderLayout.SOUTH);
	}


/**
 * controles
 */
protected class controles extends Panel implements ActionListener {
	static final long serialVersionUID = 220927L;

	public controles() {
		setLayout (new FlowLayout());
		setBackground (Color.LIGHT_GRAY);
		add (new Label ("f(x)="));
		add (tf = new TextField (s, 20));
		add (new Label ("ux="));
		add (tux = new TextField (Double.toString (ux), 5));
		add (new Label ("uy="));
		add (tuy = new TextField (Double.toString (uy), 5));
		add (ok = new Button ("Trace"));
		ok.addActionListener (this);
	}

	public void actionPerformed (ActionEvent e) {
		if (e.getSource() == ok) {
			double nux = 0.0, nuy = 0.0;
			try {
				nux = Double.parseDouble (tux.getText());
			} catch (NumberFormatException nfe) {}
			try {
				nuy = Double.parseDouble (tuy.getText());
			} catch (NumberFormatException nfe) {}
			if (nux > 0.0)
				ux = nux;
			if (nuy > 0.0)
				uy = nuy;
			tux.setText (Double.toString (ux));
			tuy.setText (Double.toString (uy));
			R.MAJ (R.X0, R.Y0, D.gw, D.gh, ux, uy);
			I.MAJ (1.0, 1.0);
			D.analyse();
			D.ccourbe();
			T.anatab();
			if (T.vide)
				T.nxy = 0;
			T.majtab();
			D.repaint();
		}
	}
}


/**
 * dessin
 */
protected class dessin extends Panel implements MouseListener, MouseMotionListener {
	static final long serialVersionUID = 220927L;
	static Image img;
	static Graphics g;
	static StringTokenizer st;
	double[] liste;
	int nliste;
	int max;
	int[] Yf;
	boolean erreur, der, dernbr, resval;
	int X, Y;
	double[] pile;
	int npile;
	Random rnd;
	int gw, gh;

//------------------------------------------------------------------------------
	private void analyse()
	{ erreur = false;
		st = new StringTokenizer (tf.getText(), "()*+-/^,", true);
		nliste = 0;
		parse();
	}

	private void parse()
	{ der = true;
		int i = 0;
		while (st.hasMoreTokens())
		{ if (p (i) == -1) break;
			i++;
		}
	}

	private int p (int i)
	{ int resultat = -1; String s = "";
		while ((st.hasMoreTokens()) && (s.length() == 0)) s = st.nextToken().trim();
		if (s.length() != 0)
		{ try { addListe (Double.valueOf (s).doubleValue(), true); resultat = 0; der = false; }
			catch (NumberFormatException excp)
			{ s = s.toUpperCase();
				if (s.equals ("X"))
				{ addListe (1.0, false);
					resultat = 0;
					der = false;
				}
				else if (s.equals ("PI"))
			 { addListe (-1.0, false);
					resultat = 0;
					der = false;
				}
				else if (s.equals ("E"))
				{ addListe (-2.0, false);
					resultat = 0;
					der = false;
				}
				else if (s.equals ("(")) { parse(); resultat = 0; }
				else if (s.equals (",")) { parse(); resultat = 0; }
				else if (s.equals (")")) { der = false; }
				else
				{ int op = nop (s);
					if ((op == -22) && (i == 0)) addListe (0.0, true);
					if ((op == 14) || (op == 15))
					{ p (i);
						addListe ((double) op, false);
					}
					else
					{ int opt = Math.abs (op);
						int opa = (i > 0) ? (int) liste [nliste - 1] : 0;
						int opat = Math.abs (opa); if ((opat < 20) || !der) opat = 0;
						int opb = 0; int opbt = 0;
						if ((opt >= 20) && (opt < opat))
						{ nliste--;
							if (nliste >= 1) opb = (int) liste [nliste - 1];
							opbt = Math.abs (opb); if (opbt < 20) opbt = 0;
							if ((opt < opbt) && (opbt < opat)) nliste--;			 
						}
						boolean b = der;
						resultat = p (i);
						addListe ((double) op, false);
						der = b;
						if (opt >= 20)
						{ if ((opt < opbt) && (opbt < opat)) addListe ((double) opb, false);						
							if (opt < opat) addListe ((double) opa, false);
						}
						der = true;
					}
				}
			}
		}
		return resultat;
	}

	private int nop (String s)
	{ int r = 0;
		if (s.equals ("ABS")) r = 2;
		else if (s.equals ("SQRT")) r = 3;
		else if (s.equals ("RAC")) r = 3;
		else if (s.equals ("LN")) r = 4;
		else if (s.equals ("EXP")) r = 5;
		else if (s.equals ("SIN")) r = 6;
		else if (s.equals ("COS")) r = 7;
		else if (s.equals ("TAN")) r = 8;
		else if (s.equals ("ASIN")) r = 9;
		else if (s.equals ("ACOS")) r = 10;
		else if (s.equals ("ATAN")) r = 11;
		else if (s.equals ("INT")) r = 12;
		else if (s.equals ("RND")) r = 13;
		else if (s.equals ("MAX")) r = 14;
		else if (s.equals ("MIN")) r = 15;
		else if (s.equals ("^")) r = 20;
		else if (s.equals ("*")) r = 21;
		else if (s.equals ("/")) r = -21;
		else if (s.equals ("+")) r = 22;
		else if (s.equals ("-")) r = -22;
		if (r == 0) erreur = true;
		return r;
	}

	private void addListe (double x, boolean b) /* b = true : x == nombre */
	{ if (nliste >= max - 1)
			if (liste == null)
			{ max = 20;
				liste = new double [max];
				pile = new double [max];
			}
			else
			{ max *= 2;
				double nf [] = new double [max];
				System.arraycopy (liste, 0, nf, 0, liste.length);
				liste = nf;
				pile = new double [max];
			}
		if (b) liste [nliste++] = 0.0;
		liste [nliste++] = x;
	}
//------------------------------------------------------------------------------
	private void ccourbe()
	{ for (int Xf = 0; Xf < R.XMAX; Xf ++)
		{ if (!erreur)
			{ double d = image (R.x (Xf));
				if (resval) Yf [Xf] = R.Y (d); else Yf [Xf] = -1;
			}
			else Yf [Xf] = -1;
		}
	}

	private double image (double x)
	{ resval = true;
		if ((liste == null) || (nliste == 0)) { resval = false; return Double.NaN; }
// NaN non reconnu par IE4 et5
		else
		{ npile = 0;
			int i = 0;
			while ((i < nliste) && (!erreur) && (resval))
			{ int id = (int) liste [i++];
				if (id == 0) pile [npile++] = liste [i++];
				else if (id == 1) pile [npile++] = x;
				else if (id == -1) pile [npile++] = Math.PI;
				else if (id == -2) pile [npile++] = Math.E;
				else if ((id >= 2) && (id < 14))
				{ if (npile == 0) erreur = true;
					else
					{ double d = pile [-- npile];
						switch (id)
						{ case 2 : d = Math.abs (d); break;
							case 3 : resval = (d >= 0.0); d = Math.sqrt (d); break;
							case 4 : resval = (d >= 0.0); d = Math.log (d); break;
							case 5 : d = Math.exp (d); break;
							case 6 : d = Math.sin (d); break;
							case 7 : d = Math.cos (d); break;
							case 8 : d = Math.tan (d); break;
							case 9 : resval = (d >= -1.0) && (d <= 1.0); d = Math.asin (d); break;
							case 10 : resval = (d >= -1.0) && (d <= 1.0); d = Math.acos (d); break;
							case 11 : d = Math.atan (d); break;
							case 12 : d = Math.floor (d); break;
							case 13 : d = rnd.nextDouble() * d;
						}
						pile [npile ++] = d;
					}
				}
				else
				{ if (npile < 2) erreur = true;
					else
					{ double d1 = pile [npile - 2];
						double d2 = pile [--npile];
						switch (id)
						{ case 14 : d1 = Math.max (d1, d2); break;
							case 15 : d1 = Math.min (d1, d2); break;
							case 20 : try { d1 = Math.pow (d1, d2); }
												catch (ArithmeticException ae) {resval = false; }
												break;
							case 21 : d1 *= d2; break;
							case -21 : resval = (d2 != 0.0); d1 /= d2; break;
							case 22 : d1 += d2; break;
							case -22 : d1 -= d2;
						}
						pile [npile - 1] = d1;
					} 
				}
			}
			if (!resval) return Double.NaN;
			else if (npile != 1) { erreur = true; return Double.NaN; }
			else return pile [0];
		}
	}
//------------------------------------------------------------------------------
	public dessin () {
		setBackground (Color.WHITE);
		addMouseMotionListener (this);
		addMouseListener (this);
	}

	private double arrondi (double d, double precision) {
		return Math.floor (d * precision) / precision;
	}

	public void update (Graphics g) {
		paint (g);
	}

	public void paint (Graphics g1) {
		if (img == null || gw != getSize().width || gh != getSize().height) {
			gw = getSize().width;
			gh = getSize().height;
			img = createImage (gw, gh);
			g = img.getGraphics();
			R = null;
		}
		if (R == null) {
			R = new Repere (gw / 2, gh / 2, gw, gh, ux, uy);
			O = new PointLibre (0.0, 0.0);
			I = new PointLibre (1.0, 1.0);
			rnd = new Random();
			Yf = new int [R.XMAX];
			String s = tf.getText();
			if ((s != null) && (s.length() != 0)) {
				analyse();
				ccourbe();
			} else
				for (int Xf = 0; Xf < R.XMAX; Xf++)
					Yf [Xf] = -1;
		}
		g.setFont (f);
		g.setColor (getBackground());
		g.fillRect (0, 0, R.XMAX, R.YMAX);

		if ((O.deplace) || (I.deplace)) {
			if (O.deplace)
				R.MAJ (R.X (O.x), R.Y (O.y), gw, gh, R.unitex, R.unitey);
			else {
				double Ix = I.x;
				double Iy = I.y;
				if ((Ix > 0.0) && (Iy > 0.0)) {
					ux = (double) (R.X (Ix) - R.X0);
					uy = (double) (R.Y0 - R.Y (Iy));
					R.MAJ (R.X0, R.Y0, gw, gh, ux, uy);
					tux.setText (Double.toString (ux));
					tuy.setText (Double.toString (uy));
				}
			} 
			O.MAJ (0.0, 0.0);
			I.MAJ (1.0, 1.0);
		}
		ccourbe();

		g.setColor (Color.BLACK);
		g.drawString ("(" + arrondi (R.x (X), 100.0) + ", " + arrondi (R.y (Y), 100.0) + ")", 2, gh - 10);

		g.setColor (Color.RED);
		R.trace (g);
		O.trace ("O", R, g);
		I.trace ("I", R, g);
		if (erreur)
			g.drawString ("Erreur de syntaxe", 2, gh - 10);
		else {
			g.setColor (Color.BLUE);
			for (int X = 0; X < R.XMAX; X++) {
				int Y = Yf [X];
				g.fillRect (X, Y, 1, 1);
			}
		}

		g.setColor (Color.BLACK);
		R.cadre (g);
		for (int i = 0; i < T.nxy; i++)
			g.fillRect (R.X (T.x [i]) - 1, R.Y (T.y [i]) - 1, 3, 3);

		g1.drawImage (img, 0, 0, this);
	}


	public void mousePressed (MouseEvent e) {
		int X = e.getX();
		int Y =  e.getY();
		if (I.deplace = I.zone (X, Y, R)) {
		} else if (O.deplace = O.zone (X, Y, R)) {
		}
	}

	public void mouseDragged (MouseEvent e) {
		int X = e.getX();
		int Y =  e.getY();
		I.bouge (X, Y, R);
		O.bouge (X, Y, R);
		repaint();
	}

	public void mouseReleased (MouseEvent e) {
		I.deplace = O.deplace = false;
	}

	public void mouseMoved (MouseEvent e) {
		int X = e.getX();
		int Y = e.getY();
		if (I != null && I.zone (X, Y, R) || O != null && O.zone (X, Y, R)) {
			setCursor (new Cursor (Cursor.HAND_CURSOR));
		} else {
			setCursor (new Cursor (Cursor.DEFAULT_CURSOR));
		}
	}

	public void mouseClicked (MouseEvent e) {}
	public void mouseEntered (MouseEvent e) {}
	public void mouseExited (MouseEvent e) {}
}


/**
 * table
 */
protected class table extends Panel implements ActionListener {
	static final long serialVersionUID = 220927L;
	TextArea ta;
	Button ok, efface;
	double[] x;
	double[] y;
	int nxy;
	TextField tarrond, tdegre;
	int arrond, degrep1;
	double darrond;
	Checkbox pasajust, puissance, affine, polynome;
	boolean vide;

	private Checkbox ajoutcb (Font f, String s, CheckboxGroup grp, boolean b) {
		Checkbox cb = new Checkbox (s, grp, b);
		cb.setFont (f);
		return cb;
	}

	public table() {
		setBackground (Color.LIGHT_GRAY);
		arrond = 2;
		darrond = 100.0;

		add (ta = new TextArea ("", 5, 50, TextArea.SCROLLBARS_HORIZONTAL_ONLY));

		Panel pan = new Panel();
		pan.setLayout (new GridLayout(4, 1));
		pan.setBackground (Color.LIGHT_GRAY);
		CheckboxGroup grp = new CheckboxGroup();
//retiré du panneau le 28/08/00
//		pan.add (pasajust = ajoutcb (f, "pas d'ajust.", grp, true));
		pasajust = ajoutcb (f, "", grp, true);
		pan.add (puissance = ajoutcb (f, "a * x ^ b", grp, false));
		pan.add (affine = ajoutcb (f, "a + b * x", grp, false));
		pan.add (polynome = ajoutcb (f, "polynôme", grp, false));
		add (pan);

		Panel gpan = new Panel();
		gpan.setBackground (Color.LIGHT_GRAY);
		gpan.setLayout (new GridLayout(3, 1));

		pan = new Panel();
		pan.add (new Label ("déc. :"));
		pan.add (tarrond = new TextField ("2"));
		gpan.add (pan);

		pan = new Panel();
		pan.add (new Label ("degré :"));
		pan.add (tdegre = new TextField ("2"));
		gpan.add (pan);

		degrep1 = 3;
		pan = new Panel();
		pan.add (efface = new Button ("Eff"));
		pan.add (ok = new Button ("Aj"));
		gpan.add (pan);

		add (gpan);

		efface.addActionListener (this);
		ok.addActionListener (this);
		x = new double [20];
		y = new double [20];

	}

	private String DSarrondi (double d) {
		if (arrond >= 0)
			d = Math.floor (d * darrond + 0.5) / darrond;
		return Double.toString (d);
	}

	private void txy (StringTokenizer st, double[] xy) {
		nxy = 0;
		for (int i = 0; i < xy.length; i++)
			xy [i] = 0.0;
		while (st.hasMoreTokens()) {
			try {
				double d = Double.parseDouble (st.nextToken());
				if (nxy >= xy.length) {
					double[] nx = new double [x.length + 20];
					System.arraycopy (x, 0, nx, 0, x.length);
					x = nx;
					double[] ny = new double [y.length + 20];
					System.arraycopy (y, 0, ny, 0, y.length);
					y = ny;
				}
				xy [nxy ++] = d;
			} catch (NumberFormatException excp) {}
		}
	}

	public void majtab() {
		String s = "x";
		for (int i = 0; i < nxy; i++)
			s = s + "\t" + Double.toString (x [i]);
		s = s + "\ny";
		for (int i = 0; i < nxy; i ++)
			s = s + "\t" + Double.toString (y [i]);
		s = s + "\nf(x)";
		double[] ecart = new double [nxy];
		boolean[] defini = new boolean [nxy];
		for (int i = 0; i < nxy; i++) {
			double d = D.image (x [i]);
			s = s + "\t";
// NaN non reconnu par IE4 et 5
			defini [i] = ! D.erreur && D.resval;
			if (defini [i]) {
				s = s + DSarrondi (d);
				ecart [i] = y [i] - d;
			} else
				s = s + "---";
		}
		s = s + "\ne";
		for (int i = 0; i < nxy; i++) {
			s = s + "\t";
			if (defini [i])
				s = s + DSarrondi (ecart [i]);
			else
				s = s + "---";
		}
		ta.setText (s);
	}

	public void anatab() {
		vide = true;
		StringTokenizer st = new StringTokenizer (ta.getText() , "\n");
		StringTokenizer st1, st2; 
		if (st.hasMoreTokens()) {
			st1 = new StringTokenizer (st.nextToken());
			if (st.hasMoreTokens()) {
				st2 = new StringTokenizer (st.nextToken());
				txy (st1, x);
				txy (st2, y);
				vide = false;
			}
		}
	}

	public void actionPerformed (ActionEvent e) {
		if (e.getSource() == efface)
			ta.setText ("");
		else if (e.getSource() == ok) {
			try {
				arrond = Integer.parseInt (tarrond.getText());
			} catch (NumberFormatException excp) {}
			if (arrond >= 0)
				darrond = Math.pow (10.0, arrond);
			tarrond.setText (Integer.toString (arrond));
			try {
				degrep1 = Integer.parseInt (tdegre.getText());
			} catch (NumberFormatException excp) {
				degrep1 --;
			}
			if (degrep1 < 0)
				degrep1 = 0;
			tdegre.setText (Integer.toString (degrep1 ++));
			anatab();
			if (vide)
				nxy = 0;
			else {
				boolean mode1 = false;
				String s;
				int dgp1 = degrep1;
				if (puissance.getState()) {
					mode1 = true;
					dgp1 = 2;
				}
				if (affine.getState())
					dgp1 = 2;
				if (puissance.getState() || affine.getState() || polynome.getState()) {
					double[][] XtX = new double [dgp1] [dgp1];
					double[] B = new double [dgp1];
					double[][] X = new double [nxy] [dgp1];
					for (int k = 0; k < nxy; k++) {
						double d = 1.0; double xk = x [k]; if (mode1) xk = Math.log (xk);
						for (int I = 0; I < dgp1; I++) {
							X [k] [I] = d;
							d *= xk;
						}
					}
					for (int I = 0; I < dgp1; I++) {
						for (int J = 0; J <= I; J++) {
							double d = 0.0;
							for (int k = 0; k < nxy; k++)
								d += X [k] [I] * X [k] [J];
								XtX [I] [J] = d;
							}
					}
					for (int I = 0; I < dgp1; I++) {
						double d = 0.0;
						for (int k = 0; k < nxy; k++) {
							double yk = y [k];
							if (mode1)
								yk = Math.log (yk);
								d += X [k] [I] * yk;
							}
							B [I] = d;
					}
					Choleski (XtX, B, dgp1);
					double B0 = B [0];
					double B1 = 0.0;
					if (dgp1 > 1)
						B1 = B [1];
					if (mode1) {
						s = DSarrondi (Math.exp(B0)) + " * x ^ ";
						s += (B1 >= 0.0) ? DSarrondi (B1) : "(" + DSarrondi (B1) + ")";
					} else {
						s = DSarrondi (B0);									 
						if (dgp1 > 0) {
							s += (B1 >= 0.0) ? " + " : " - ";
							s += DSarrondi (Math.abs(B1)) + " * x ";
							for (int I = 2; I < dgp1; I++) {
								s += (B [I] >= 0.0) ? " + " : " - ";
								s += DSarrondi (Math.abs(B [I])) + " * x ^ " + Integer.toString (I);
							}
						}
					}
					tf.setText (s);
					D.analyse();
				}
			}
			majtab();
			D.repaint();
		}
	}

/**
 * Calcul A-1*B par la méthode de Choleski. La matrice A doit être symétrique
 * définie positive.
 * B contient en sortie les solutions.
 */

	public void Choleski (double[][] A, double[] B, int N) {
		for (int I = 0; I < N; I++) {
			int IM1 = I - 1;
			double S = A [I] [I];
			for (int J = 0; J <= IM1; J++) {
				double x = A [I] [J];
				S = S - x * x;
			}
			A [I] [I] = Math.sqrt (S);
			for (int J = I + 1; J < N; J++) {
				S = A [J] [I];
				for (int K = 0; K <= IM1; K++)
					S = S - A [J] [K] * A [I] [K];
				A [J] [I] = S / A [I] [I];
			}
		}
		for (int I = 0; I < N; I++) {
			int IM1 = I - 1;
			double S = B [I];
			for (int J = 0; J <= IM1; J++)
				S = S - A [I] [J] * B [J];
			B [I] = S / A [I] [I];
		}
		for (int I = N - 1; I >= 0; I--) {
			int IP1 = I + 1;
			double S = B [I];
			for (int J = N - 1; J >= IP1; J--)
				S = S - A [J] [I] * B [J];
			B [I] = S / A [I] [I];
		}
	}

}

	public static void main (String [] args) {
		int w = 600;
		int h = 450;
		ajustf a = new ajustf();
		JFrame f = new JFrame ("ajustf");
		f.setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE);
		f.add (a);
		f.setSize (w, h);
		f.setVisible (true);
	}

}
