package geo;

/**
 * Point d'une droite déplaçable à la souris.
 */
public class PointSurDroite extends PointLibre {
/** Support du point mobile */
	public Droite d;

/** Construit un point sur la droite d à partir de la position (X, Y) dans la fenêtre d'affichage */
	public PointSurDroite (int X, int Y, Droite d, Repere R) {
		super (X, Y, R);
		this.d = d;
		MAJ();
	}

/** Construit un point sur la droite d à partir des coordonnées (x, y) */
	public PointSurDroite (double x, double y, Droite d) {
		super (x, y);
		this.d = d;
		MAJ();
	}

/** Pour un point en cours de déplacement, met à jour les coordonnées (X, Y) dans la fenêtre */
	public void bouge (int X, int Y, Repere R) {
		if (deplace && R.affiche (X, Y)) {
			this.x = R.x (X);
			this.y = R.y (Y);
			MAJ();
		}
	}

/** Met à jour les coordonnées du point. */
	public void MAJ() {
		defini = d.defini;
		if (defini) {
			try {
				double u = (d.a * x + d.b * y + d.c) / (d.a * d.a + d.b * d.b);
				x = x - u * d.a;
				y = y - u * d.b;
			}
			catch (ArithmeticException ae) {
				defini = false;
			}
		}
	}

}
